import java.io.*;
import java.util.*;

public class GCTest {

	public static void main (String [] args) {
		for (int i = 0;
		     i < 10000;
		     ++i) {
			new A();

			if ( i%2 != 0) {
				new B();
			}
		}

		System.out.println(ObjectCounter.cache);
	}
}

class A {

	public A() {
		ObjectCounter.count(ObjectCounter.UP);
	}

	public void finalize() throws Throwable {
		super.finalize();
		ObjectCounter.count(ObjectCounter.DOWN);
	}
}

class B extends A {

}

class ObjectCounter {
	public static final long UP = 1L;
	public static final long DOWN = -1L;

	public static Map cache = new TreeMap();

	private static Throwable t = new Throwable();
	private static CharArrayWriter caw = new CharArrayWriter();
	private static PrintWriter pw = new PrintWriter(caw);


	public static synchronized void count(long amount) {
		/* get stack trace */
		t.fillInStackTrace();

		/* get stack trace string */
		caw.reset();
		t.printStackTrace(pw);
		String trace = caw.toString();

		/* store in hash map and increase the counter */
		Long count = (Long) cache.get(trace);

		if (count == null) {
			cache.put(trace, new Long(0));
		}
		else {
			cache.put(trace, new Long(count.intValue() + amount));
		}
	}
}
